## contour 0.6.1.7494

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16 FATAL_ERROR)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

include(Version)
GetVersionInformation(CONTOUR_VERSION CONTOUR_VERSION_STRING)
file(WRITE "${CMAKE_BINARY_DIR}/version.txt" "${CONTOUR_VERSION_STRING}")
project(contour VERSION "${CONTOUR_VERSION}" LANGUAGES CXX)

# setting defaults
if (NOT(CMAKE_CXX_STANDARD))
    set(CMAKE_CXX_STANDARD 20)
endif()
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

set(CMAKE_COLOR_DIAGNOSTICS ON)

set(QT_VERSION_DEFAULT  "6")

if(NOT CONTOUR_QT_VERSION)
    set(CONTOUR_QT_VERSION "${QT_VERSION_DEFAULT}")
endif()

if((CMAKE_CXX_COMPILER_ID STREQUAL "Clang") OR (CMAKE_CXX_COMPILER_ID STREQUAL "GNU"))
    set(CMAKE_CXX_FLAGS_DEBUG "-Og -g")
endif()

include(EnableCcache)
include(ClangTidy)

if(NOT WIN32 AND NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
    set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Choose the build mode." FORCE)
    set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS Debug Release MinSizeRel RelWithDebInfo)
endif()

find_package(Threads)

if(DEFINED MSVC)
    add_definitions(-D_USE_MATH_DEFINES)
    add_definitions(-DNOMINMAX)
    add_compile_options(/utf-8)
    add_compile_options(/nologo)
endif()

if (CONTOUR_BUILD_WITH_MIMALLOC)
    add_definitions(-DCONTOUR_BUILD_WITH_MIMALLOC)
endif()

# Enables STL container checker if not building a release.
if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    add_definitions(-D_GLIBCXX_ASSERTIONS)
endif()

find_program(ADDR2LINE NAMES addr2line llvm-addr2line)
set(ADDR2LINE_DEFAULT OFF)
if(NOT("${ADDR2LINE}" STREQUAL ""))
    set(ADDR2LINE_DEFAULT ON)
endif()
message(STATUS "addr2line: ${ADDR2LINE}")

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(MAINTAINER_MODE ON)
else()
    set(MAINTAINER_MODE OFF)
endif()

option(CONTOUR_TESTING "Enables building of unittests for libterminal [default: ${MAINTAINER_MODE}]" ${MAINTAINER_MODE})
option(CONTOUR_FRONTEND_GUI "Enables GUI frontend." ON)
option(CONTOUR_COVERAGE "Builds with codecov [default: OFF]" OFF)
option(CONTOUR_SANITIZE "Builds with Address sanitizer enabled [default: OFF]" "OFF")
option(CONTOUR_STACKTRACE_ADDR2LINE "Uses addr2line to pretty-print SEGV stacktrace." ${ADDR2LINE_DEFAULT})
option(CONTOUR_BUILD_WITH_MIMALLOC "Builds with mimalloc [default: OFF]" OFF)
option(CONTOUR_INSTALL_TOOLS "Installs tools, if built [default: OFF]" OFF)
option(CONTOUR_PACKAGE_TERMINFO "Package terminfo files" ON)
option(CONTOUR_WITH_UTEMPTER "Build with utempter support [default: ON]" ON)
option(CONTOUR_USE_CPM "Use CPM to fetch dependencies [default: OFF]" OFF)
option(CONTOUR_BUILD_STATIC "Link to static libraries [default: OFF]" OFF)


if(CONTOUR_BUILD_STATIC)
    set(BUILD_SHARED_LIBS OFF)
    set(CMAKE_POSITION_INDEPENDENT_CODE ON)
    set(CMAKE_LINK_SEARCH_END_STATIC ON)
    set(CMAKE_EXE_LINKER_FLAGS "-static-libgcc -static-libstdc++")
endif()

if(NOT WIN32 AND NOT CONTOUR_SANITIZE AND NOT CMAKE_CONFIGURATION_TYPES)
    set(CONTOUR_SANITIZE "OFF" CACHE STRING "Choose the sanitizer mode." FORCE)
    set_property(CACHE CONTOUR_SANITIZE PROPERTY STRINGS OFF address thread)
endif()

# ----------------------------------------------------------------------------
# code coverage

if(CONTOUR_COVERAGE AND NOT MSVC)
    add_compile_options(-g --coverage)
    set(CMAKE_EXE_LINKER_FLAGS "--coverage ${CMAKE_EXE_LINKER_FLAGS}")
    set(CONTOUR_CODE_COVERAGE_ENABLED ON)
else()
    set(CONTOUR_CODE_COVERAGE_ENABLED OFF)
endif()

if(NOT(CONTOUR_SANITIZE STREQUAL "OFF"))
    message(STATUS "Enabling ${san} sanitizer.")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-omit-frame-pointer -fsanitize=address -fsanitize-address-use-after-scope")
else()
    message(STATUS "No sanitizer enabled.")
endif()

if(CONTOUR_TESTING)
    enable_testing()
endif()
# ----------------------------------------------------------------------------

if(CONTOUR_USE_CPM)
    # download CPM.cmake
    file(
        DOWNLOAD
        https://github.com/cpm-cmake/CPM.cmake/releases/download/v0.38.3/CPM.cmake
        ${CMAKE_CURRENT_BINARY_DIR}/cmake/CPM.cmake
        EXPECTED_HASH SHA256=cc155ce02e7945e7b8967ddfaff0b050e958a723ef7aad3766d368940cb15494
    )
    include(${CMAKE_CURRENT_BINARY_DIR}/cmake/CPM.cmake)
endif()


include(ContourThirdParties)
add_subdirectory(src)
add_subdirectory(examples)

# ----------------------------------------------------------------------------
# Summary

if("${CCACHE}" STREQUAL "")
    set(USING_CCACHE_STRING "OFF")
else()
    set(USING_CCACHE_STRING "${CCACHE}")
endif()

if("${CMAKE_CXX_CLANG_TIDY}" STREQUAL "")
    set(USING_TIDY_STRING "OFF")
else()
    set(USING_TIDY_STRING "ON (${CMAKE_CXX_CLANG_TIDY})")
endif()

if(CONTOUR_FRONTEND_GUI)
    find_package(Qt${CONTOUR_QT_VERSION} COMPONENTS Core QUIET)
    if (NOT Qt${CONTOUR_QT_VERSION}_FOUND)
        set(QT_VERSION ${Qt5_VERSION})
    else()
        set(QT_VERSION ${Qt6_VERSION})
    endif()
endif()

add_custom_target(package-verbose
    COMMAND ${CMAKE_CPACK_COMMAND} --config CPackConfig.cmake --verbose
    COMMENT "Build package with verbose output"
    VERBATIM
    USES_TERMINAL
)

macro(ContourConfigurationSummary)
    message(STATUS "==============================================================================")
    message(STATUS "    Contour (${CONTOUR_VERSION_STRING})")
    message(STATUS "------------------------------------------------------------------------------")
    message(STATUS "System:                                             ${CMAKE_SYSTEM_PROCESSOR} (${CMAKE_SYSTEM_NAME})")
    message(STATUS "Build type:                                         ${CMAKE_BUILD_TYPE}")
    message(STATUS "C++ standard:                                       C++${CMAKE_CXX_STANDARD} (${CMAKE_CXX_COMPILER_ID})")
    message(STATUS "Using ccache:                                       ${USING_CCACHE_STRING}")
    message(STATUS "Build with sanitizer:                               ${CONTOUR_SANITIZE}")
    message(STATUS "Build unit tests:                                   ${CONTOUR_TESTING}")
    message(STATUS "Enable with code coverage:                          ${CONTOUR_CODE_COVERAGE_ENABLED}")
    message(STATUS "Build contour frontend GUI:                         ${CONTOUR_FRONTEND_GUI}")
    if(CONTOUR_FRONTEND_GUI)
        message(STATUS "Build contour using Qt:                             ${CONTOUR_QT_VERSION} (${QT_VERSION})")
    endif()
    message(STATUS "Build contour using mimalloc:                       ${CONTOUR_BUILD_WITH_MIMALLOC}")
    message(STATUS "Clang Tidy:                                         ${USING_TIDY_STRING}")
    message(STATUS "|> Enable performance metrics:                      ${CONTOUR_PERF_STATS}")
    message(STATUS "------------------------------------------------------------------------------")
endmacro()

ContourThirdPartiesSummary2()
ContourConfigurationSummary()

=== docs/requirements.txt ===
mkdocs-material
mkdocs-exclude
mkdocs-glightbox
mkdocs-video
pygments

=== examples/CMakeLists.txt ===
if(LIBTERMINAL_TESTING)
    if(UNIX)
        add_executable(watch-mouse-events watch-mouse-events.cpp)
        target_link_libraries(watch-mouse-events vtbackend)

        add_executable(detect-dark-light-mode detect-dark-light-mode.cpp)
    endif()
endif()

=== src/CMakeLists.txt ===
if(("${CMAKE_CXX_COMPILER_ID}" MATCHES "GNU") OR ("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang"))
    #(TODO: first get rid of these warnings) add_compile_options(-Werror)
endif()

include(PedanticCompiler)

add_subdirectory(crispy)
add_subdirectory(text_shaper)
add_subdirectory(vtpty)
add_subdirectory(vtparser)
add_subdirectory(vtbackend)
add_subdirectory(vtrasterizer)

if(CONTOUR_FRONTEND_GUI)
    add_subdirectory(contour)
endif()

=== cmake/cincludeme/CMakeLists.txt ===
add_executable(cincludeme cincludeme.cpp)

=== src/contour/CMakeLists.txt ===
set(AppId "org.contourterminal.Contour")

if(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
    set(FREEBSD TRUE)
elseif(${CMAKE_SYSTEM_NAME} MATCHES "OpenBSD")
    set(OPENBSD TRUE)
elseif(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    set(LINUX TRUE)
endif()

option(CONTOUR_PERF_STATS "Enables debug printing some performance stats." OFF)

NumberToHex(${PROJECT_VERSION_MAJOR} HEX_MAJOR)
NumberToHex(${PROJECT_VERSION_MINOR} HEX_MINOR)
NumberToHex(${PROJECT_VERSION_PATCH} HEX_PATCH)

# {{{ Setup QT_COMPONENTS
# QT_COMPONENTS is the list of Qt libraries Contour requires for building.
# NB: Widgets is rquired for SystemTrayIcon's fallback implementation
set(QT_COMPONENTS Core Gui Qml Quick QuickControls2 Network Multimedia Widgets)
if(CONTOUR_QT_VERSION EQUAL 6)
    list(APPEND QT_COMPONENTS OpenGL OpenGLWidgets Core5Compat)
endif()
if(NOT(WIN32) AND NOT(APPLE) AND (CONTOUR_QT_VERSION EQUAL 5))
    list(APPEND QT_COMPONENTS X11Extras)
endif()
# }}}

message(STATUS "Qt components: ${QT_COMPONENTS}")

find_package(Qt${CONTOUR_QT_VERSION} COMPONENTS ${QT_COMPONENTS} REQUIRED)

add_subdirectory(display)

if(APPLE)
    #set(CMAKE_INSTALL_RPATH "@executable_path")
    set(CMAKE_INSTALL_RPATH "@executable_path/../Frameworks")
    set(CMAKE_BUILD_RPATH "${CMAKE_INSTALL_RPATH}")
    set(CMAKE_MACOSX_RPATH ON)
    #set(CMAKE_BUILD_WITH_INSTALL_RPATH ON)
    find_package(Qt6 COMPONENTS Core Quick REQUIRED)
endif()

set(_source_files
    CaptureScreen.cpp CaptureScreen.h
    main.cpp
)

if(CONTOUR_FRONTEND_GUI)
    list(APPEND _header_files
        Actions.h
        Audio.h
        BlurBehind.h
        Config.h
        ContourApp.h
        ContourGuiApp.h
        TerminalSession.h
        TerminalSessionManager.h
        helper.h
    )
    list(APPEND _source_files
        Actions.cpp
        Audio.cpp
        BlurBehind.cpp
        Config.cpp
        ContourApp.cpp
        ContourGuiApp.cpp
        TerminalSession.cpp
        TerminalSessionManager.cpp
        helper.cpp
    )
endif()

if(WIN32)
    list(APPEND _source_files contour.rc)
endif()

set(_qt_resources resources.qrc)
if(CONTOUR_QT_VERSION EQUAL "5")
    qt5_add_resources(_qt_resources ${_qt_resources})
else()
    qt_add_resources(_qt_resources ${_qt_resources})
endif()

# {{{ configure QML files and their imports
function(DeclareQmlImport name import version)
    set(import_v6_alternative ${ARGN})

    if(CONTOUR_QT_VERSION EQUAL "5")
        set(${name} "${import} ${version}" PARENT_SCOPE)
    elseif("${import_v6_alternative}" STREQUAL "")
        set(${name} "${import}" PARENT_SCOPE)
    else()
        set(${name} "${import_v6_alternative}" PARENT_SCOPE)
    endif()
endfunction()

function(DeclareQML name name_qt5 name_qt6)
    if(CONTOUR_QT_VERSION EQUAL "5")
        set(${name} "${name_qt5}" PARENT_SCOPE)
    else()
        set(${name} "${name_qt6}" PARENT_SCOPE)
    endif()
endfunction()

DeclareQmlImport(qml_import_ContourTerminal "Contour.Terminal" "1.0")
DeclareQmlImport(qml_import_QtQuick "QtQuick" "2.6")
DeclareQmlImport(qml_import_QtQuickControls "QtQuick.Controls" "2.2")
DeclareQmlImport(qml_import_QtQuickLayouts "QtQuick.Layouts" "1.11")
DeclareQmlImport(qml_import_QtQuickWindow "QtQuick.Window" "2.6")
DeclareQmlImport(qml_import_QtQuicklabs "Qt.labs.platform" "1.1")
DeclareQmlImport(qml_import_QtMultimedia "QtMultimedia" "5.12")
DeclareQmlImport(qml_import_QtGraphicalEffects "QtGraphicalEffects" "1.12" "Qt5Compat.GraphicalEffects")
DeclareQML(qml_audio "Audio" "AudioOutput")
DeclareQML(qml_media_player "" "audioOutput: bellAudioOutput")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/ui.template/RequestPermission.qml.in ${CMAKE_CURRENT_SOURCE_DIR}/ui/RequestPermission.qml)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/ui.template/Terminal.qml.in ${CMAKE_CURRENT_SOURCE_DIR}/ui/Terminal.qml)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/ui.template/main.qml.in ${CMAKE_CURRENT_SOURCE_DIR}/ui/main.qml)
# }}}

set(_qml_files
    ui.template/RequestPermission.qml.in
    ui.template/Terminal.qml.in
    ui.template/main.qml.in
)

source_group(Sources FILES ${_source_files})
source_group(Headers FILES ${_header_files})
source_group(Resources FILES ${_qt_resources})
source_group(QML FILES ${_qml_files})

add_executable(contour)
target_sources(contour PRIVATE ${_source_files} ${_header_files} ${_qt_resources} ${_qml_files})

set_target_properties(contour PROPERTIES AUTOMOC ON)
set_target_properties(contour PROPERTIES AUTORCC ON)

target_include_directories(contour PRIVATE "${CMAKE_CURRENT_BINARY_DIR}")

# {{{ declare compiler definitions
# target_compile_definitions(contour PRIVATE $<$<OR:$<CONFIG:Debug>,$<CONFIG:RelWithDebInfo>>:QT_QML_DEBUG>)
target_compile_definitions(contour PRIVATE $<$<CONFIG:Debug>:QT_QML_DEBUG>)
target_compile_definitions(contour PRIVATE $<$<CONFIG:Debug>:QMLJSDEBUGGER>)
target_compile_definitions(contour PRIVATE $<$<CONFIG:Debug>:QT_DECLARATIVE_DEBUG>)
target_compile_definitions(contour PRIVATE
    CONTOUR_VERSION_MAJOR=${PROJECT_VERSION_MAJOR}
    CONTOUR_VERSION_MINOR=${PROJECT_VERSION_MINOR}
    CONTOUR_VERSION_PATCH=${PROJECT_VERSION_PATCH}
    CONTOUR_VERSION_STRING="${CONTOUR_VERSION_STRING}"
    CONTOUR_PROJECT_SOURCE_DIR="${PROJECT_SOURCE_DIR}"
    CONTOUR_APP_ID="${AppId}"
)

# Disable all deprecated Qt functions prior to Qt 6.0
target_compile_definitions(contour PRIVATE QT_DISABLE_DEPRECATED_BEFORE=0x050F00)

# Create custom target to execute contour
add_custom_target(run COMMAND contour)

if(CONTOUR_PERF_STATS)
    target_compile_definitions(contour PRIVATE CONTOUR_PERF_STATS)
endif()

if(CONTOUR_FRONTEND_GUI)
    target_compile_definitions(contour PRIVATE CONTOUR_FRONTEND_GUI)
endif()

if("${CMAKE_BUILD_TYPE}" STREQUAL "Debug")
    target_compile_definitions(contour PRIVATE CONTOUR_GUI_SOURCE_DIR="${CMAKE_CURRENT_SOURCE_DIR}")
endif()
# }}}

# {{{ platform specific target set_target_properties
if(WIN32)
    if (NOT ("${CMAKE_BUILD_TYPE}" STREQUAL "Debug"))
        set_target_properties(contour PROPERTIES
            # Tell MSVC to create a GUI application.
            WIN32_EXECUTABLE ON

            # Tell MSVC to use main instead of WinMain for Windows subsystem executables.
            LINK_FLAGS "/ENTRY:mainCRTStartup"
        )
    endif()
elseif(APPLE)
    set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../../cmake/Modules" ${CMAKE_MODULE_PATH})
    set_target_properties(contour PROPERTIES
        OUTPUT_NAME "contour"
        MACOSX_RPATH ON
        MACOSX_BUNDLE ON
        MACOSX_BUNDLE_BUNDLE_NAME "Contour"
        MACOSX_BUNDLE_INFO_STRING "Contour Terminal Emulator"
        MACOSX_BUNDLE_GUI_IDENTIFIER "${AppId}"
        MACOSX_BUNDLE_LONG_VERSION_STRING "${CONTOUR_VERSION_STRING}"
        MACOSX_BUNDLE_SHORT_VERSION_STRING "${CONTOUR_VERSION}"
        MACOSX_BUNDLE_BUNDLE_VERSION "${CONTOUR_VERSION}"
        XCODE_ATTRIBUTE_PRODUCT_NAME "Contour Terminal Emulator"
        # TODO: MACOSX_BUNDLE_ICON_FILE "contour.icns"
        # TODO: RESOURCE "images/icon.icns"
    )
endif()
# }}}

if(FREEBSD)
    # FreeBSD does not find yaml-cpp in /usr/local but weirdly everything else.
    target_link_directories(contour PUBLIC "/usr/local/lib")
endif()

if (TARGET yaml-cpp::yaml-cpp)
    set(YAML_CPP_LIBRARIES yaml-cpp::yaml-cpp)
else()
    set(YAML_CPP_LIBRARIES yaml-cpp)
endif()

target_link_libraries(contour
    PRIVATE
    ContourTerminalDisplay
    crispy::core
    vtbackend
    vtrasterizer
    ${YAML_CPP_LIBRARIES}
)

# {{{ GUI: Declare Qt build dependencies
if(CONTOUR_FRONTEND_GUI)
    if(OPENBSD)
        find_package(X11 REQUIRED)
    endif()
    if(CONTOUR_QT_VERSION EQUAL "6")
        target_link_libraries(contour
            PRIVATE
            Qt6::Core
            Qt6::Core5Compat
            Qt6::Multimedia
            Qt6::Network
            Qt6::OpenGL
            Qt6::Qml
            Qt6::QuickControls2
            Qt6::Widgets
        )

        if(OPENBSD)
            target_link_libraries(contour PRIVATE X11::xcb X11::xcb_cursor)
        elseif(NOT(WIN32) AND NOT(APPLE))
            target_link_libraries(contour PRIVATE xcb)
        endif()
    else()
        target_link_libraries(contour
            PRIVATE
            Qt5::Core
            Qt5::Gui
            Qt5::Multimedia
            Qt5::Network
            Qt5::Widgets
        )
        if(OPENBSD)
            target_link_libraries(contour PRIVATE Qt5::X11Extras X11::xcb)
        elseif(NOT(WIN32) AND NOT(APPLE))
            target_link_libraries(contour PRIVATE Qt5::X11Extras xcb)
        endif()
    endif()
    if(CONTOUR_BUILD_STATIC)
        qt_import_qml_plugins(contour)
    endif()
endif()
# }}}

# {{{ Build terminfo file
if(NOT(WIN32) AND CONTOUR_PACKAGE_TERMINFO)
    set(terminfo_file "contour.terminfo")
    set(terminfo_basedir "${CMAKE_CURRENT_BINARY_DIR}/terminfo")
    set_source_files_properties("${terminfo_file}" PROPERTIES GENERATED TRUE)
    find_program(TIC tic REQUIRED)
    if(${TIC-NOTFOUND})
        message(FATAL_ERROR "Executable tic not found.")
    else()
        message(STATUS "Executable tic found (${TIC}).")
    endif()
    add_custom_command(
        TARGET contour POST_BUILD
        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
        COMMAND contour generate terminfo to ${terminfo_file} && ${TIC} -x -o "${terminfo_basedir}" "${terminfo_file}"
        DEPENDS "${terminfo_file}"
        COMMENT "Compiling ${terminfo_file}"
        BYPRODUCTS "${terminfo_file}"
        VERBATIM
    )
endif()
# }}}

# ====================================================================================
# INSTALLER
# ====================================================================================

set(CMAKE_INSTALL_DEFAULT_COMPONENT_NAME "contour")

# {{{ CPACK variable definitions
if(NOT(CPACK_GENERATOR))
    if(APPLE)
        set(CPACK_GENERATOR DragNDrop)
    elseif(WIN32)
        set(CPACK_GENERATOR WIX ZIP)
    endif()
endif()

set(CPACK_PACKAGE_NAME "Contour")
set(CPACK_PACKAGE_VENDOR "https://github.com/contour-terminal/contour/")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "`contour` is a modern terminal emulator, for everyday use.")
set(CPACK_PACKAGE_CONTACT "Christian Parpart <christian@parpart.family>")
if(WIN32)
    # XXX: WIX does only allow x.x.x.x patterns.
    set(CPACK_PACKAGE_VERSION "${CONTOUR_VERSION}")
else()
    set(CPACK_PACKAGE_VERSION "${CONTOUR_VERSION_STRING}")
endif()
set(CPACK_PACKAGE_EXECUTABLES contour "Contour Terminal Emulator")
set(CPACK_PACKAGE_ICON "${CMAKE_CURRENT_SOURCE_DIR}/res/images/contour-logo.ico")
#TODO: set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_SOURCE_DIR}/README.md")
#TODO? set(CPACK_WIX_PRODUCT_ICON "${CMAKE_CURRENT_SOURCE_DIR}/res/images/contour-logo.ico")
#TODO: set(CPACK_WIX_UI_DIALOG "${CMAKE_CURRENT_SOURCE_DIR}/res/images/contour-logo-256.png")
#TODO: set(CPACK_WIX_UI_BANNER "${CMAKE_CURRENT_SOURCE_DIR}/res/images/contour-logo-256.png")
set(CPACK_RESOURCE_FILE_README "${CMAKE_SOURCE_DIR}/README.md")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/LICENSE.txt")
set(CPACK_CREATE_DESKTOP_LINKS contour)
set(CPACK_WIX_PRODUCT_GUID "0E736497-2B72-4117-95E9-54EC6D${HEX_MAJOR}${HEX_MINOR}${HEX_PATCH}")
set(CPACK_WIX_UPGRADE_GUID "0E736497-2B72-4117-95E9-54EC6D${HEX_MAJOR}${HEX_MINOR}00")
if(WIN32)
    set(CPACK_PACKAGE_INSTALL_DIRECTORY "Contour Terminal Emulator ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}")
endif()
if(APPLE)
    set(CPACK_PACKAGE_ICON "${CMAKE_CURRENT_SOURCE_DIR}/res/images/contour-logo.icns")
endif()
# }}}

# {{{ Qt bundle installation helpers
set(INSTALLED_QT_VERSION ${CONTOUR_QT_VERSION})

function(_qt_get_plugin_name_with_version target out_var)
    string(REGEX REPLACE "^Qt::(.+)" "Qt${INSTALLED_QT_VERSION}::\\1" qt_plugin_with_version "${target}")
    if(TARGET "${qt_plugin_with_version}")
        set("${out_var}" "${qt_plugin_with_version}" PARENT_SCOPE)
    else()
        set("${out_var}" "" PARENT_SCOPE)
    endif()
endfunction()

# if(APPLE)
#    # Required when packaging, and set CMAKE_INSTALL_PREFIX to "/"

=== src/crispy/CMakeLists.txt ===
if(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
    set(FREEBSD TRUE)
endif()

# --------------------------------------------------------------------------------------------------------
# crispy::core

option(STRONGHASH_USE_INTRINSICS "Build StrongHash with AES-NI (x86-64) / NEON (ARM64) support [default: ON]" ON)

set(crispy_SOURCES
    App.cpp App.h
    BufferObject.cpp BufferObject.h
    CLI.cpp CLI.h
    Comparison.h
    LRUCache.h
    StrongLRUCache.h
    StackTrace.cpp StackTrace.h
    TrieMap.h
    algorithm.h
    assert.h
    base64.h
    compose.h
    defines.h
    escape.h
    file_descriptor.h
    flags.h
    interpolated_string.cpp interpolated_string.h
    logstore.cpp logstore.h
    overloaded.h
    reference.h
    ring.h
    times.h
    utils.cpp utils.h
)

add_library(crispy-core STATIC ${crispy_SOURCES})
add_library(crispy::core ALIAS crispy-core)

set_target_properties(crispy-core PROPERTIES CXX_CLANG_TIDY "${CLANG_TIDY_EXE}")

if(STRONGHASH_USE_AES_NI)
    target_compile_definitions(crispy-core PUBLIC -DSTRONGHASH_USE_AES_NI=1)
endif()

if(MSVC)
    target_compile_definitions(crispy-core PUBLIC NOMINMAX)
endif()

set(CRISPY_CORE_LIBS range-v3::range-v3 unicode::unicode Microsoft.GSL::GSL boxed-cpp::boxed-cpp reflection-cpp::reflection-cpp)

# if compiler is not MSVC
if(NOT MSVC)
    if(CMAKE_SYSTEM_PROCESSOR STREQUAL x86_64 OR CMAKE_SYSTEM_PROCESSOR STREQUAL amd64 OR CMAKE_SYSTEM_PROCESSOR STREQUAL AMD64)
        target_compile_options(crispy-core PUBLIC -maes)
    elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL aarch64) # ARM64
        target_compile_options(crispy-core PUBLIC -march=armv8-a+fp+simd+crypto+crc)
    elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL ARM64)
        message(STATUS "Target architecture: ${CMAKE_SYSTEM_PROCESSOR}")
    else()
        message(WARNING "Target architecture not detected: ${CMAKE_SYSTEM_PROCESSOR}")
    endif()
endif()

target_compile_features(crispy-core PUBLIC cxx_std_17)
target_link_libraries(crispy-core PUBLIC ${CRISPY_CORE_LIBS})
target_include_directories(crispy-core PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/include>
)

macro(target_compile_definitions_if _target _visibility)
    foreach(_option IN ITEMS ${ARGN})
        if(${${_option}})
            message(STATUS "[${_target}] Adding compile definition: ${_option}")
            target_compile_definitions(${_target} ${_visibility} ${_option})
        else()
            message(STATUS "[${_target}] Skipping compile definition: ${_option}")
        endif()
    endforeach()
endmacro()

if(UNIX)
    include(CheckIncludeFiles)
    include(CheckIncludeFileCXX)
    include(CheckFunctionExists)

    check_function_exists(backtrace HAVE_BACKTRACE)
    check_function_exists(backtrace_symbols HAVE_BACKTRACE_SYMBOLS)
    check_function_exists(dladdr HAVE_DLADDR)
    check_function_exists(dlsym HAVE_DLSYM)
    check_include_files(dlfcn.h HAVE_DLFCN_H)
    check_include_files(cxxabi.h HAVE_CXXABI_H)
    check_include_files(execinfo.h HAVE_EXECINFO_H)
    check_include_files(sys/select.h HAVE_SYS_SELECT_H)
    check_include_files(unwind.h HAVE_UNWIND_H)

    # The following options are all important to get stacktrace dumping working
    target_link_libraries(crispy-core PUBLIC ${CMAKE_DL_LIBS})
    if(NOT(FREEBSD))
        target_link_options(crispy-core PUBLIC -rdynamic)
    endif()
    if(CONTOUR_STACKTRACE_ADDR2LINE)
        target_compile_definitions(crispy-core PUBLIC CONTOUR_STACKTRACE_ADDR2LINE=1)
    endif()
    target_compile_definitions_if(crispy-core PUBLIC
        HAVE_BACKTRACE
        HAVE_BACKTRACE_SYMBOLS
        HAVE_CXXABI_H
        HAVE_DLADDR
        HAVE_DLFCN_H
        HAVE_DLSYM
        HAVE_EXECINFO_H
        HAVE_SYS_SELECT_H
        HAVE_UNWIND_H
    )
endif()

# --------------------------------------------------------------------------------------------------------
# crispy_test

option(CRISPY_TESTING "Enables building of unittests for crispy library [default: ON]" ${CONTOUR_TESTING})
if(CRISPY_TESTING)
    enable_testing()
    add_executable(crispy_test
        BufferObject_test.cpp
        CLI_test.cpp
        LRUCache_test.cpp
        StrongLRUCache_test.cpp
        StrongLRUHashtable_test.cpp
        TrieMap_test.cpp
        base64_test.cpp
        compose_test.cpp
        interpolated_string_test.cpp
        utils_test.cpp
        result_test.cpp
        ring_test.cpp
        sort_test.cpp
        times_test.cpp
    )
target_link_libraries(crispy_test range-v3::range-v3 Catch2::Catch2WithMain crispy::core)
    add_test(crispy_test ./crispy_test)
endif()
message(STATUS "[crispy] Compile unit tests: ${CRISPY_TESTING}")

=== src/text_shaper/CMakeLists.txt ===
set(text_shaper_SRC
    font.cpp font.h
    font_locator.h
    font_locator_provider.cpp font_locator_provider.h
    mock_font_locator.cpp mock_font_locator.h
    open_shaper.cpp open_shaper.h
    shaper.cpp shaper.h
)

if("${CMAKE_SYSTEM}" MATCHES "Windows")
    list(APPEND text_shaper_SRC directwrite_analysis_wrapper.h)
    list(APPEND text_shaper_SRC directwrite_locator.cpp directwrite_locator.h)
    list(APPEND text_shaper_SRC directwrite_shaper.cpp directwrite_shaper.h)
endif()
if(APPLE)
    list(APPEND text_shaper_SRC coretext_locator.h coretext_locator.mm)
endif()
if("${CMAKE_SYSTEM}" MATCHES "Linux" OR "${CMAKE_SYSTEM}" MATCHES "FreeBSD" OR "${CMAKE_SYSTEM}" MATCHES "OpenBSD")
    list(APPEND text_shaper_SRC fontconfig_locator.cpp fontconfig_locator.h)
endif()

# TODO: coretext_shaper.cpp coretext_shaper.h
add_library(text_shaper STATIC ${text_shaper_SRC})
set_target_properties(text_shaper PROPERTIES CXX_CLANG_TIDY "${CLANG_TIDY_EXE}")

set(TEXT_SHAPER_LIBS unicode::unicode boxed-cpp::boxed-cpp)
list(APPEND TEXT_SHAPER_LIBS range-v3::range-v3)
list(APPEND TEXT_SHAPER_LIBS Microsoft.GSL::GSL)

if(APPLE)
    enable_language(OBJCXX)
    enable_language(OBJC)
    list(APPEND TEXT_SHAPER_LIBS "-framework Foundation")
    list(APPEND TEXT_SHAPER_LIBS "-framework AppKit")
    list(APPEND TEXT_SHAPER_LIBS "-framework CoreText")
    find_package(PkgConfig REQUIRED)
    find_package(Fontconfig REQUIRED)
    find_package(Freetype REQUIRED)
    pkg_check_modules(harfbuzz REQUIRED IMPORTED_TARGET harfbuzz)
    execute_process(
        COMMAND sh -c "brew --prefix harfbuzz | cut -d. -f1 | tr -d $'\n'"
        OUTPUT_VARIABLE HARFBUZZ_APPLE_INCLUDE)
    include_directories("${HARFBUZZ_APPLE_INCLUDE}/include")
    list(APPEND TEXT_SHAPER_LIBS Freetype::Freetype)
    list(APPEND TEXT_SHAPER_LIBS PkgConfig::harfbuzz)
    list(APPEND TEXT_SHAPER_LIBS Fontconfig::Fontconfig)
elseif("${CMAKE_SYSTEM}" MATCHES "Linux" OR "${CMAKE_SYSTEM}" MATCHES "FreeBSD" OR "${CMAKE_SYSTEM}" MATCHES "OpenBSD")
    find_package(Fontconfig REQUIRED)
    find_package(Freetype REQUIRED)
    list(APPEND TEXT_SHAPER_LIBS Freetype::Freetype)
    if(CONTOUR_BUILD_STATIC)
        # qt exports harfbuzz as a library with such name
        list(APPEND TEXT_SHAPER_LIBS harfbuzz)
    else()
        pkg_check_modules(harfbuzz REQUIRED IMPORTED_TARGET harfbuzz)
        list(APPEND TEXT_SHAPER_LIBS PkgConfig::harfbuzz)
    endif()
    list(APPEND TEXT_SHAPER_LIBS Fontconfig::Fontconfig)
elseif("${CMAKE_SYSTEM}" MATCHES "Windows")
    # installed via vcpkg
    find_package(harfbuzz CONFIG REQUIRED)
    find_package(Freetype REQUIRED)
    list(APPEND TEXT_SHAPER_LIBS harfbuzz harfbuzz::harfbuzz)
    list(APPEND TEXT_SHAPER_LIBS Freetype::Freetype)
    list(APPEND TEXT_SHAPER_LIBS dwrite)
endif()

target_include_directories(text_shaper PRIVATE "${CMAKE_CURRENT_BINARY_DIR}")
target_include_directories(text_shaper PUBLIC ${PROJECT_SOURCE_DIR}/src ${CMAKE_SOURCE_DIR}/src)
target_link_libraries(text_shaper PRIVATE ${TEXT_SHAPER_LIBS})

message(STATUS "[text_shaper] Librarires: ${TEXT_SHAPER_LIBS}")

=== src/vtbackend/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

find_package(Threads)

option(LIBTERMINAL_TESTING "Enables building of unittests for libterminal [default: ON]" ${CONTOUR_TESTING})
option(LIBTERMINAL_LOG_TRACE "Enables VT sequence tracing. [default: ON]" ON)

# This is an optimization feature that hopefully improves performance when enabled.
# But it's currently disabled by default as I am not fully satisfied with it yet.
option(LIBTERMINAL_PASSIVE_RENDER_BUFFER_UPDATE "Updates the render buffer within the terminal thread if set to ON (otherwise the render buffer is actively refreshed in the render thread)." OFF)

option(LIBTERMINAL_BUILD_BENCH_HEADLESS "Builds bench-headless CLI tool to benchmark libvtbackend [default: OFF]" OFF)

set(vtbackend_HEADERS
    Capabilities.h
    cell/CellConcept.h
    cell/CellConfig.h
    cell/SimpleCell.h
    cell/CompactCell.h
    CellUtil.h
    Charset.h
    Color.h
    ColorPalette.h
    Functions.h
    GraphicsAttributes.h
    Grid.h
    Hyperlink.h
    Image.h
    InputBinding.h
    InputGenerator.h
    Line.h
    MatchModes.h
    MockTerm.h
    RenderBuffer.h
    RenderBufferBuilder.h
    Screen.h
    Selector.h
    Sequence.h
    SequenceBuilder.h
    SixelParser.h
    StatusLineBuilder.h
    Terminal.h
    VTType.h
    VTWriter.h
    Viewport.h
    ViInputHandler.h
    ViCommands.h
    JumpHistory.h
    primitives.h
)

set(vtbackend_SOURCES
    Capabilities.cpp
    cell/CompactCell.cpp
    Charset.cpp
    Color.cpp
    ColorPalette.cpp
    Functions.cpp
    Grid.cpp
    Image.cpp
    InputBinding.cpp
    InputGenerator.cpp
    Line.cpp
    MatchModes.cpp
    MockTerm.cpp
    RenderBuffer.cpp
    RenderBufferBuilder.cpp
    Screen.cpp
    Selector.cpp
    Sequence.cpp
    SixelParser.cpp
    StatusLineBuilder.cpp
    Terminal.cpp
    VTType.cpp
    VTWriter.cpp
    Viewport.cpp
    ViInputHandler.cpp
    ViCommands.cpp
    JumpHistory.cpp
    primitives.cpp
)

add_library(vtbackend STATIC ${vtbackend_SOURCES} ${vtbackend_HEADERS})
set_target_properties(vtbackend PROPERTIES CXX_CLANG_TIDY "${CLANG_TIDY_EXE}")
target_compile_definitions(vtbackend PRIVATE
    LIBTERMINAL_VERSION_MAJOR=${PROJECT_VERSION_MAJOR}
    LIBTERMINAL_VERSION_MINOR=${PROJECT_VERSION_MINOR}
    LIBTERMINAL_VERSION_PATCH=${PROJECT_VERSION_PATCH}
    LIBTERMINAL_VERSION_STRING="${CONTOUR_VERSION_STRING}"
    LIBTERMINAL_NAME="${PROJECT_NAME}"
)

target_include_directories(vtbackend PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/include>
)

target_link_libraries(vtbackend PUBLIC
    Microsoft.GSL::GSL
    Threads::Threads
    crispy::core
    range-v3::range-v3
    unicode::unicode
    vtparser
    vtpty
)

if(LIBTERMINAL_LOG_TRACE)
    target_compile_definitions(vtbackend PUBLIC LIBTERMINAL_LOG_TRACE=1)
endif()
if(CONTOUR_PERF_STATS)
    target_compile_definitions(vtbackend PUBLIC CONTOUR_PERF_STATS=1)
endif()

if(LIBTERMINAL_PASSIVE_RENDER_BUFFER_UPDATE AND NOT(WIN32))
    target_compile_definitions(vtbackend PUBLIC LIBTERMINAL_PASSIVE_RENDER_BUFFER_UPDATE=1)
endif()

# ----------------------------------------------------------------------------
if(LIBTERMINAL_TESTING)
    enable_testing()
    add_executable(vtbackend_test
        Capabilities_test.cpp
        Color_test.cpp
        InputGenerator_test.cpp
        Selector_test.cpp
        Functions_test.cpp
        Grid_test.cpp
        Line_test.cpp
        Screen_test.cpp
        Sequence_test.cpp
        Terminal_test.cpp
        SixelParser_test.cpp
        ViCommands_test.cpp
    )
    target_link_libraries(vtbackend_test Catch2::Catch2WithMain vtbackend)
    add_test(vtbackend_test ./vtbackend_test)

    if (LIBTERMINAL_BUILD_BENCH_HEADLESS)
        add_executable(bench-headless bench-headless.cpp)
        target_compile_definitions(bench-headless PRIVATE
            CONTOUR_VERSION_MAJOR=${PROJECT_VERSION_MAJOR}
            CONTOUR_VERSION_MINOR=${PROJECT_VERSION_MINOR}
            CONTOUR_VERSION_PATCH=${PROJECT_VERSION_PATCH}
            CONTOUR_VERSION_STRING="${CONTOUR_VERSION_STRING}"
            CONTOUR_PROJECT_SOURCE_DIR="${PROJECT_SOURCE_DIR}"
        )

        target_link_libraries(bench-headless
            termbench::termbench
            vtbackend
        )

        if(CONTOUR_INSTALL_TOOLS)
            if(APPLE)
                # See: https://stackoverflow.com/questions/35612687/cmake-macos-x-bundle-with-bundleutiliies-for-qt-application/48035834#48035834
                set(APP_NAME contour)
                set(App_Contents "${APP_NAME}.app/Contents")
                set(INSTALL_RUNTIME_DIR "${App_Contents}/MacOS")
                set(INSTALL_CMAKE_DIR "${App_Contents}/Resources")

                set(INSTALL_RUNTIME_DIR "${App_Contents}/MacOS")
                install(TARGETS bench-headless
                    BUNDLE DESTINATION . COMPONENT Runtime
                    RUNTIME DESTINATION "${INSTALL_RUNTIME_DIR}" COMPONENT Runtime
                )
            else()
                install(TARGETS bench-headless DESTINATION bin)
            endif()
        endif()
    endif()
endif()

option(VTBACKEND_DOC_TOOL "Tool to generate documentation for vtbackend [default: OFF]" OFF)
if(VTBACKEND_DOC_TOOL)
    add_executable(vtbackend-doc-tool doc-tool.cpp)
    target_link_libraries(vtbackend-doc-tool vtbackend)
    # install(TARGETS vtbackend-doc-tool DESTINATION bin)
endif()

message(STATUS "[vtbackend] Compile unit tests: ${LIBTERMINAL_TESTING}")
message(STATUS "[vtbackend] Enable VT sequence tracing: ${LIBTERMINAL_LOG_TRACE}")
message(STATUS "[vtbackend] Enable passive render buffer update: ${LIBTERMINAL_PASSIVE_RENDER_BUFFER_UPDATE}")
message(STATUS "[vtbackend] Build bench-headless: ${LIBTERMINAL_BUILD_BENCH_HEADLESS}")
message(STATUS "[vtbackend] Build documentation tool: ${VTBACKEND_DOC_TOOL}")

=== src/vtparser/CMakeLists.txt ===
#cmake_minimum_required(VERSION 3.10)
#project(vtparser VERSION "0.0.0" LANGUAGES CXX)

add_library(vtparser STATIC
    Parser.cpp
    Parser.h
    Parser-impl.h
    ParserEvents.h
)
set_target_properties(vtparser PROPERTIES CXX_CLANG_TIDY "${CLANG_TIDY_EXE}")
target_link_libraries(vtparser PUBLIC
    Microsoft.GSL::GSL
    range-v3::range-v3
    unicode::unicode
)
target_include_directories(vtparser PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/include>
)

option(VTPARSER_TESTING "Enables building of unittests for vtparser [default: ON]" ${CONTOUR_TESTING})
if(VTPARSER_TESTING)
    enable_testing()
    add_executable(vtparser_test
        Parser_test.cpp
    )
    target_link_libraries(vtparser_test vtparser Catch2::Catch2WithMain)
    add_test(vtparser_test ./vtparser_test)
endif()

=== src/vtpty/CMakeLists.txt ===
if (CMAKE_SYSTEM_NAME MATCHES "Linux")
    set(LINUX TRUE)
endif()

# Platform suffix can be either _win32 or _unix.
if(WIN32)
    set(PLATFORM_SUFFIX "_win32")
else()
    set(PLATFORM_SUFFIX "_unix")
endif()

if(EXISTS "/.flatpak-info")
    set(CONTOUR_WITH_UTEMPTER OFF)
endif()

set(vtpty_LIBRARIES crispy::core Microsoft.GSL::GSL)

set(vtpty_SOURCES
    MockPty.cpp
    MockViewPty.cpp
    Process${PLATFORM_SUFFIX}.cpp
    Pty.cpp
)

set(vtpty_HEADERS
    MockPty.h
    MockViewPty.h
    PageSize.h
    Process.h
    Pty.h
)

set(_include_SshSession_module FALSE)
if(WIN32)
    find_package(Libssh2 CONFIG REQUIRED)
    set(_include_SshSession_module TRUE)
else()
    find_package(PkgConfig REQUIRED)
    pkg_check_modules(LIBSSH2 libssh2)
    if(LIBSSH2_FOUND)
        set(_include_SshSession_module TRUE)
    endif()
endif()
if(_include_SshSession_module)
    add_compile_definitions(VTPTY_LIBSSH2)
    list(APPEND vtpty_SOURCES SshSession.cpp)
    list(APPEND vtpty_HEADERS SshSession.h)
    message(STATUS "[vtpty] Builtin-SSH support enabled")
else()
    message(STATUS "[vtpty] Builtin-SSH support disabled")
endif()

if(LINUX)
    if(CONTOUR_WITH_UTEMPTER)
        set(vtpty_LIBRARIES ${vtpty_LIBRARIES} utempter)
    endif()
endif()

if(UNIX)
    list(APPEND vtpty_LIBRARIES util)
    list(APPEND vtpty_SOURCES UnixPty.cpp UnixUtils.cpp)
    list(APPEND vtpty_SOURCES UnixPty.h UnixUtils.h)
else()
    list(APPEND vtpty_SOURCES ConPty.cpp)
    list(APPEND vtpty_HEADERS ConPty.h)
    #TODO: list(APPEND vtpty_SOURCES WinPty.cpp)
endif()

add_library(vtpty STATIC ${vtpty_SOURCES} ${vtpty_HEADERS})
set_target_properties(vtpty PROPERTIES CXX_CLANG_TIDY "${CLANG_TIDY_EXE}")
if(CONTOUR_WITH_UTEMPTER)
    target_compile_definitions(vtpty PRIVATE UTEMPTER=1)
endif()
if(_include_SshSession_module)
    target_compile_definitions(vtpty PUBLIC VTPTY_LIBSSH2=1)
endif()
if(LIBSSH2_FOUND)
    target_compile_options(vtpty PRIVATE ${LIBSSH2_CFLAGS_OTHER})
    target_include_directories(vtpty PRIVATE ${LIBSSH2_INCLUDE_DIRS})
    target_link_libraries(vtpty PRIVATE ${LIBSSH2_LINK_LIBRARIES})
elseif(WIN32)
    target_link_libraries(vtpty PRIVATE $<IF:$<TARGET_EXISTS:Libssh2::libssh2_shared>,Libssh2::libssh2_shared,Libssh2::libssh2_static>)
endif()
target_include_directories(vtpty PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/include>
)
target_link_libraries(vtpty PUBLIC ${vtpty_LIBRARIES})

=== src/vtrasterizer/CMakeLists.txt ===
set(_header_files
    BackgroundRenderer.h
    BoxDrawingRenderer.h
    CursorRenderer.h
    DecorationRenderer.h
    GridMetrics.h
    ImageRenderer.h
    Pixmap.h
    RenderTarget.h
    Renderer.h
    TextClusterGrouper.h
    TextRenderer.h
    TextureAtlas.h
    utils.h
)

set(_source_files
    BackgroundRenderer.cpp
    BoxDrawingRenderer.cpp
    CursorRenderer.cpp
    DecorationRenderer.cpp
    ImageRenderer.cpp
    Pixmap.cpp
    RenderTarget.cpp
    Renderer.cpp
    TextClusterGrouper.cpp
    TextRenderer.cpp
    utils.cpp
)

set(_test_files
    TextClusterGrouper_test.cpp
)

source_group(Sources FILES ${_source_files})
source_group(Headers FILES ${_header_files})
source_group(Tests FILES ${_test_files})

add_library(vtrasterizer STATIC)
target_sources(vtrasterizer PRIVATE ${_source_files} PUBLIC ${_header_files})

set_target_properties(vtrasterizer PROPERTIES CXX_CLANG_TIDY "${CLANG_TIDY_EXE}")

target_include_directories(vtrasterizer PUBLIC ${PROJECT_SOURCE_DIR}/src ${CMAKE_SOURCE_DIR}/src)
target_link_libraries(vtrasterizer PUBLIC vtbackend crispy::core text_shaper range-v3::range-v3)

if(CONTOUR_TESTING)
    enable_testing()
    add_executable(vtrasterizer_test)
    target_sources(vtrasterizer_test PRIVATE ${_test_files})
    target_link_libraries(vtrasterizer_test vtrasterizer Catch2::Catch2WithMain)
    add_test(vtrasterizer_test ./vtrasterizer_test)
endif()

message(STATUS "[vtrasterizer] Compile unit tests: ${CONTOUR_TESTINGG}")

=== debian/changelog ===
contour (0.6.1.7494-1) unstable; urgency=medium

  * Initial release

 -- April Lu <apr3vau@outlook.com>  Tue, 01 Jul 2025 18:38:02 +0800

=== debian/control ===
Source: contour
Section: devel
Priority: optional
Maintainer: April Lu <apr3vau@outlook.com>
Build-Depends: debhelper-compat (= 13), cmake, extra-cmake-modules, g++-13,
 libfreetype-dev, libharfbuzz-dev, libfontconfig-dev, qt6-base-dev,
 qt6-declarative-dev, qt6-5compat-dev, libyaml-cpp-dev, catch2, libmsgsl-dev,
 librange-v3-dev, libutempter-dev, extra-cmake-modules, libssh2-1-dev,
 libx11-xcb-dev, ncurses-bin, libgl1-mesa-dev, libglvnd-dev, libunicode-dev,
 libboxed-cpp-dev, libreflection-cpp-dev,
 qml6-module-qt-labs-platform, qml6-module-qtqml-workerscript,
 qml6-module-qtquick-controls, qml6-module-qtquick-layouts,
 qml6-module-qtmultimedia, qml6-module-qtquick-templates,
 qml6-module-qtquick-window, qml6-module-qt5compat-graphicaleffects,
 qt6-base-dev-tools, qt6-multimedia-dev, qt6-qpa-plugins
Standards-Version: 4.6.0
Homepage: https://github.com/contour-terminal/contour
Rules-Requires-Root: no

Package: contour
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Modern C++ Terminal Emulator
 contour is a modern and actually fast, modal, virtual terminal emulator,
 for everyday use. It is aiming for power users with a modern feature mindset.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
        -DCMAKE_CXX_COMPILER=g++-13 \
        -DCMAKE_BUILD_TYPE=Release \
        -DCONTOUR_QT_VERSION=6

=== debian/watch ===
version=4
# GitHub hosted projects
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%contour-$1.tar.gz%" \
   https://github.com/contour-terminal/contour/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## contour 2.0+git2012021501

=== contourd/CMakeLists.txt ===
project(contourd)

# This should be REQUIRED once we get rid of the hack below
find_package(QtMobility)

# build stuff
# ===============================================================================================
include_directories(
  ${contour_SOURCE_DIR}/contourd/location
  ${contour_SOURCE_DIR}/contourd/recommendation
  ${contour_BINARY_DIR}
  ${QT_INCLUDES}
  ${KDE4_INCLUDES}
  ${NEPOMUK_INCLUDE_DIR}
  ${SOPRANO_INCLUDE_DIR}
#hack to find qt-mobility includes. TODO: get cmake macro
  ${INCLUDE_INSTALL_DIR}/QtMobility
  ${INCLUDE_INSTALL_DIR}/QtMobility/QtMobility
  ${QT_INCLUDE_DIR}/QtMobility
  ${QT_INCLUDE_DIR}/QtMobility/QtMobility
#this uses the cmake macro
  ${QTMOBILITY_INCLUDE_DIR}
)

configure_file(
  config-features.h.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/config-features.h
)

add_subdirectory(recommendation/plugins)

set(recommendationmanager_SRC
  recommendation/RecommendationManager.cpp
  recommendation/RecommendationEngine.cpp
  recommendation/RecommendationItem.cpp
  recommendation/RecommendationScriptEngine.cpp

  recommendation/sensors/dbus/DBusSensor.cpp

  location/LocationManager.cpp
  location/network-engines/NetworkNotifier.cpp
  location/network-engines/dummy/DummyNetworkNotifier.cpp
  location/network-engines/connman/ConnmanNetworkNotifier.cpp
  location/network-engines/connman/connman-manager.cpp
  location/network-engines/connman/connman-service.cpp

  main.cpp
)

qt4_add_dbus_adaptor(
  recommendationmanager_SRC recommendation/org.kde.contour.RecommendationManager.xml
  recommendation/RecommendationManager.h Contour::RecommendationManager
)

qt4_add_dbus_adaptor(
  recommendationmanager_SRC location/org.kde.LocationManager.xml
  location/LocationManager.h Contour::LocationManager
)

qt4_add_dbus_adaptor(
  recommendationmanager_SRC location/network-engines/dummy/org.kde.LocationManager.DummyNetworkNotifier.xml
  location/network-engines/dummy/DummyNetworkNotifier.h DummyNetworkNotifier
)

qt4_add_dbus_adaptor(
  recommendationmanager_SRC location/network-engines/connman/org.kde.LocationManager.ConnmanNetworkNotifier.xml
  location/network-engines/connman/ConnmanNetworkNotifier.h ConnmanNetworkNotifier
)

find_file(kext_onto_src kext.trig PATH_SUFFIXES "ontology/kde" PATHS ${CMAKE_INSTALL_PREFIX}/share ENV XDG_DATA_DIRS)

soprano_add_ontology(recommendationmanager_SRC
    ${kext_onto_src}
    "KExt" "Nepomuk::Vocabulary" "trig"
    )

soprano_add_ontology(recommendationmanager_SRC
    ${SHAREDDESKTOPONTOLOGIES_ROOT_DIR}/nepomuk/nao.trig
    "NAO" "Nepomuk::Vocabulary" "trig"
    )

soprano_add_ontology(recommendationmanager_SRC
    ${SHAREDDESKTOPONTOLOGIES_ROOT_DIR}/nie/nie.trig
    "NIE" "Nepomuk::Vocabulary" "trig"
    )

soprano_add_ontology(recommendationmanager_SRC
    ${SHAREDDESKTOPONTOLOGIES_ROOT_DIR}/nie/nco.trig
    "NCO" "Nepomuk::Vocabulary" "trig"
    )

########################################################################
set(ADDITIONAL_LINK_LIBRARIES)

set(recommendationmanager_SRC
    ${recommendationmanager_SRC}
    location/network-engines/solid/SolidNetworkNotifier.cpp
    )

set(ADDITIONAL_LINK_LIBRARIES
    ${ADDITIONAL_LINK_LIBRARIES}
    ${KDE4_SOLID_LIBS}
    )

########################################################################

kde4_add_executable(contour
  ${recommendationmanager_SRC}
)

target_link_libraries(
  contour
  ${QT_QTCORE_LIBRARY}
  ${QT_QTSCRIPT_LIBRARY}
  ${KDE4_KDECORE_LIBS}
  ${KDE4_KIO_LIBS}
  ${SOPRANO_LIBRARIES}
  ${NEPOMUK_LIBRARIES}
  ${NEPOMUK_QUERY_LIBRARIES}
  ${ADDITIONAL_LINK_LIBRARIES}
  kworkspace
  solidcontrol
  solidcontrolifaces
  QtLocation
  QtContacts
  QtSensors
)

install(FILES
    contour-recommendationengine.desktop
    DESTINATION ${SERVICETYPES_INSTALL_DIR}
    )

install(FILES
    contour-recommendationengine-qtscript.desktop
    DESTINATION ${SERVICETYPES_INSTALL_DIR}
    )

install(FILES
    contour.desktop DESTINATION
    ${AUTOSTART_INSTALL_DIR}
    )

install(TARGETS
    contour
    ${INSTALL_TARGETS_DEFAULT_ARGS}
    )

message("AAAAAAAA ${DATA_INSTALL_DIR}")

# install(FILES
#     location/network-engines/connman/org.kde.LocationManager.ConnmanWatcher.py
#
#     DESTINATION
#     ${DATA_INSTALL_DIR}/locationmanager/
#
#     PERMISSIONS
#     OWNER_READ OWNER_WRITE OWNER_EXECUTE
#     GROUP_READ GROUP_EXECUTE
#     WORLD_READ WORLD_EXECUTE
#     )

=== debian/changelog ===
contour (2.0+git2012021501-0ubuntu2) precise; urgency=low

  * contour depends on contour-data

 -- Jonathan Riddell <jriddell@ubuntu.com>  Thu, 15 Mar 2012 11:29:47 +0000

contour (2.0+git2012021501-0ubuntu1) precise; urgency=low

  * Initial release

 -- Rodrigo Belem <rbelem@ubuntu.com>  Tue, 14 Feb 2012 15:09:17 -0400

=== debian/control ===
Source: contour
Section: kde
Priority: extra
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Rodrigo Belem <rbelem@ubuntu.com>
Build-Depends: debhelper (>= 7.3.16~), quilt (>= 0.46-7~), cmake (>= 2.8.1),
 pkg-kde-tools (>= 0.12), kdelibs5-dev, qtmobility-dev, kde-runtime,
 shared-desktop-ontologies, kde-workspace-dev, libkactivities-dev
Standards-Version: 3.9.2
Homepage: http://www.kde.org/

Package: contour
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, contour-data (= ${source:Version})
Description: a context centric shell for the Plasma Contour Active workspace
 Contour is a data-centric user interface for the Plasma Contour Active
 workspace, suitable for tablets, smartphones, in-car or set top boxes.
 .
 This package is part of the Plasma Contour Active Platform.

Package: contour-data
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: shared data files for the KDE Plasma Contour shell
 This package contains architecture-independent shared data files needed for the
 Contour installation.
 .
 This package is part of the Plasma Contour Active Platform.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/pkg-kde-tools/qt-kde-team/2/debian-qt-kde.mk

TARFILE?=contour_2.0+git$(shell date +%Y%m%d)01.orig.tar.gz
DIRNAME?=contour-2.0+git$(shell date +%Y%m%d)01

get-orig-source:
	git archive --format=tar --prefix=$(DIRNAME)/ --remote=git://anongit.kde.org/contour Active/Two | gzip -c9 > ../$(TARFILE)

../$(TARFILE): get-orig-source

.PHONY: override_dh_auto_test
